:mod:`art.attacks.evasion`
==========================
.. automodule:: art.attacks.evasion

Adversarial Patch
-----------------
.. autoclass:: AdversarialPatch
   :members:
   :special-members:

Adversarial Patch - Numpy
-------------------------
.. autoclass:: AdversarialPatchNumpy
   :members:
   :special-members:

Adversarial Patch - PyTorch
---------------------------
.. autoclass:: AdversarialPatchPyTorch
   :members:
   :special-members:

Adversarial Patch - TensorFlowV2
--------------------------------
.. autoclass:: AdversarialPatchTensorFlowV2
   :members:
   :special-members:

Adversarial Texture - PyTorch
-----------------------------
.. autoclass:: AdversarialTexturePyTorch
   :members:
   :special-members:

Auto Attack
-----------
.. autoclass:: AutoAttack
   :members:
   :special-members:

Auto Projected Gradient Descent (Auto-PGD)
------------------------------------------
.. autoclass:: AutoProjectedGradientDescent
   :members:
   :special-members:

Auto Conjugate Gradient (Auto-CG)
---------------------------------
.. autoclass:: AutoConjugateGradient
   :members:
   :special-members:

Boundary Attack / Decision-Based Attack
---------------------------------------
.. autoclass:: BoundaryAttack
   :members:
   :special-members:

Brendel and Bethge Attack
-------------------------
.. autoclass:: BrendelBethgeAttack
   :members:
   :special-members:

Carlini and Wagner L_0 Attack
-----------------------------
.. autoclass:: CarliniL0Method
   :members:
   :special-members:

Carlini and Wagner L_2 Attack
-----------------------------
.. autoclass:: CarliniL2Method
   :members:
   :special-members:

Carlini and Wagner L_inf Attack
-------------------------------
.. autoclass:: CarliniLInfMethod
   :members:
   :special-members:

Carlini and Wagner ASR Attack
-----------------------------
.. autoclass:: CarliniWagnerASR
   :members:
   :special-members:

Composite Adversarial Attack - PyTorch
--------------------------------------
.. autoclass:: CompositeAdversarialAttackPyTorch
   :members:
   :special-members:

Decision Tree Attack
--------------------
.. autoclass:: DecisionTreeAttack
   :members:
   :special-members:

DeepFool
--------
.. autoclass:: DeepFool
   :members:
   :special-members:

DPatch
------
.. autoclass:: DPatch
   :members:
   :special-members:

RobustDPatch
------------
.. autoclass:: RobustDPatch
   :members:
   :special-members:

Elastic Net Attack
------------------
.. autoclass:: ElasticNet
   :members:
   :special-members:

Fast Gradient Method (FGM)
--------------------------
.. autoclass:: FastGradientMethod
   :members:
   :special-members:

Feature Adversaries - Numpy
---------------------------
.. autoclass:: FeatureAdversariesNumpy
   :members:
   :special-members:

Feature Adversaries - PyTorch
-----------------------------
.. autoclass:: FeatureAdversariesPyTorch
   :members:
   :special-members:

Feature Adversaries - TensorFlow
--------------------------------
.. autoclass:: FeatureAdversariesTensorFlowV2
   :members:
   :special-members:

Frame Saliency Attack
---------------------
.. autoclass:: FrameSaliencyAttack
   :members:
   :special-members:

Geometric Decision Based Attack
-------------------------------
.. autoclass:: GeoDA
   :members:
   :special-members:

GRAPHITE - Blackbox
-------------------
.. autoclass:: GRAPHITEBlackbox
   :members:
   :special-members:

GRAPHITE - Whitebox - PyTorch
-----------------------------
.. autoclass:: GRAPHITEWhiteboxPyTorch
   :members:
   :special-members:

High Confidence Low Uncertainty Attack
--------------------------------------
.. autoclass:: HighConfidenceLowUncertainty
   :members:
   :special-members:

HopSkipJump Attack
------------------
.. autoclass:: HopSkipJump
   :members:
   :special-members:

Imperceptible ASR Attack
------------------------
.. autoclass:: ImperceptibleASR
   :members:
   :special-members:

Imperceptible ASR Attack - PyTorch
----------------------------------
.. autoclass:: ImperceptibleASRPyTorch
   :members:
   :special-members:

Basic Iterative Method (BIM)
----------------------------
.. autoclass:: BasicIterativeMethod
   :members:
   :special-members:

Projected Gradient Descent (PGD)
--------------------------------
.. autoclass:: ProjectedGradientDescent
   :members:
   :special-members:

Projected Gradient Descent (PGD) - Numpy
----------------------------------------
.. autoclass:: ProjectedGradientDescentNumpy
   :members:
   :special-members:

Projected Gradient Descent (PGD) - PyTorch
------------------------------------------
.. autoclass:: ProjectedGradientDescentPyTorch
   :members:
   :special-members:

Projected Gradient Descent (PGD) - TensorFlowV2
-----------------------------------------------
.. autoclass:: ProjectedGradientDescentTensorFlowV2
   :members:
   :special-members:

LaserAttack
-----------
.. autoclass:: LaserAttack
   :members:
   :special-members:

LowProFool
----------
.. autoclass:: LowProFool
   :members:
   :special-members:

NewtonFool
----------
.. autoclass:: NewtonFool
   :members:
   :special-members:

Malware Gradient Descent - TensorFlow
-------------------------------------
.. autoclass:: MalwareGDTensorFlow
   :members:
   :special-members:

Over The Air Flickering Attack - PyTorch
----------------------------------------
.. autoclass:: OverTheAirFlickeringPyTorch
   :members:
   :special-members:

Overload Attack - PyTorch
-------------------------
.. autoclass:: OverloadPyTorch
   :members:
   :special-members:

PixelAttack
-----------
.. autoclass:: PixelAttack
   :members:
   :special-members:

ThresholdAttack
---------------
.. autoclass:: ThresholdAttack
   :members:
   :special-members:

Jacobian Saliency Map Attack (JSMA)
-----------------------------------
.. autoclass:: SaliencyMapMethod
   :members:
   :special-members:

Shadow Attack
-------------
.. autoclass:: ShadowAttack
   :members:
   :special-members:

ShapeShifter Attack
-------------------
.. autoclass:: ShapeShifter
   :members:
   :special-members:

Sign-OPT Attack
---------------
.. autoclass:: SignOPTAttack
   :members:
   :special-members:
   
Simple Black-box Adversarial Attack
-----------------------------------
.. autoclass:: SimBA
   :members:
   :special-members:

Spatial Transformations Attack
------------------------------
.. autoclass:: SpatialTransformation
   :members:
   :special-members:

Square Attack
-------------
.. autoclass:: SquareAttack
   :members:
   :special-members:

Targeted Universal Perturbation Attack
--------------------------------------
.. autoclass:: TargetedUniversalPerturbation
   :members:
   :special-members:

Universal Perturbation Attack
-----------------------------
.. autoclass:: UniversalPerturbation
   :members:
   :special-members:

Virtual Adversarial Method
--------------------------
.. autoclass:: VirtualAdversarialMethod
   :members:
   :special-members:

Wasserstein Attack
------------------
.. autoclass:: Wasserstein
   :members:
   :special-members:

Zeroth-Order Optimization (ZOO) Attack
--------------------------------------
.. autoclass:: ZooAttack
   :members:
   :special-members:
